#include <iostream>
using namespace std;



int main()
{
    int t;
    int n,m,x;
    int odgovor = 1;
    cin >> t;
    for (int i=0;i<t;i++){
       odgovor = 1;
       cin >> n >> m;
       long long broj_prihvacenih[n];
       long long broj_neprihvacenih[m];
       for (int y=0;y<n;y++){
        cin >> broj_prihvacenih[y];
       }
       long long najmanji = broj_prihvacenih[0];
       long long drugi_najmanji = broj_prihvacenih[1];
       for (int z=0;z<m;z++){
        cin >> broj_neprihvacenih[z];
       }
       for (int j=0;j<n;j++){
            if (najmanji > broj_prihvacenih[j]){
                najmanji = broj_prihvacenih[j];
            }
       }
       for (int j=0;j<n;j++){
        if (broj_prihvacenih[j] < drugi_najmanji && broj_prihvacenih[j] > najmanji){
            drugi_najmanji = broj_prihvacenih[j];
        }
       }
       x = drugi_najmanji - najmanji;
       int test = najmanji;
       for (int k=0;k<m;k++){
            test = test + x;
            for (int l=0;l<m;l++){
                if (test == broj_neprihvacenih[l]){
                    odgovor = 0;
                    k = m;
                    l = m;
                }
            }

       }
       cout << odgovor << endl;

    }
}